<?php

////////////////////////////////////////////////////////////////////
// Settig Theme-options
////////////////////////////////////////////////////////////////////
    include_once( trailingslashit( get_template_directory() ) . '/lib/plugin-activation.php' );  
    include_once( trailingslashit( get_template_directory() ) . '/lib/theme-config.php' );

////////////////////////////////////////////////////////////////////
// Theme Information
////////////////////////////////////////////////////////////////////

    load_theme_textdomain( 'blogmaster', get_template_directory() . '/languages' );


////////////////////////////////////////////////////////////////////
// Enqueue Styles (normal style.css and bootstrap.css)
////////////////////////////////////////////////////////////////////
    function blogmaster_theme_stylesheets()
    {
        wp_enqueue_style('blogmaster-bootstra-css', get_template_directory_uri() . '/css/bootstrap.css', array(), '1', 'all' );
        wp_enqueue_style( 'blogmaster-stylesheet', get_stylesheet_uri(), array(), '1', 'all' );
        // load Font Awesome css
	      wp_enqueue_style('blogmaster-font-awesome', get_template_directory_uri() . '/css/font-awesome.min.css', false );
        // load Flexslider css
        wp_enqueue_style('blogmaster-flexslider-css', get_template_directory_uri() . '/css/flexslider.css', 'style');
    }
    add_action('wp_enqueue_scripts', 'blogmaster_theme_stylesheets');


////////////////////////////////////////////////////////////////////
// Register Bootstrap JS with jquery
////////////////////////////////////////////////////////////////////
    function blogmaster_theme_js()
    {
        wp_enqueue_script('blogmaster-bootstrap-js', get_template_directory_uri() . '/js/bootstrap.min.js',array( 'jquery' ),array(),true );
        wp_enqueue_script('blogmaster-theme-js', get_template_directory_uri() . '/js/customscript.js',array( 'jquery' ),array(),true );
        wp_enqueue_script('blogmaster-flexslider-js', get_template_directory_uri() . '/js/jquery.flexslider-min.js', array('jquery'));    
    }
    add_action('wp_enqueue_scripts', 'blogmaster_theme_js');

////////////////////////////////////////////////////////////////////
// Add Title Tag Support with Regular Title Tag injection Fall back.
////////////////////////////////////////////////////////////////////

function blogmaster_title_tag() {
    add_theme_support( 'title-tag' );
}

add_action( 'after_setup_theme', 'blogmaster_title_tag' );

////////////////////////////////////////////////////////////////////
// Register Custom Navigation Walker include custom menu widget to use walkerclass
////////////////////////////////////////////////////////////////////

    require_once('lib/wp_bootstrap_navwalker.php'); 


////////////////////////////////////////////////////////////////////
// Register Menus
////////////////////////////////////////////////////////////////////

        register_nav_menus(
            array(
                'main_menu' => __('Main Menu', 'blogmaster'),
            )
        );

////////////////////////////////////////////////////////////////////
// Register the Sidebar(s)
////////////////////////////////////////////////////////////////////
add_action( 'widgets_init', 'blogmaster_widgets_init' );
function blogmaster_widgets_init() {
        register_sidebar(
            array(
            'name' => __('Right Sidebar', 'blogmaster'),
            'id' => 'blogmaster-right-sidebar',
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget' => '</div>',
            'before_title' => '<h3>',
            'after_title' => '</h3>',
        ));

        register_sidebar(
            array(
            'name' => __('Left Sidebar', 'blogmaster'),
            'id' => 'blogmaster-left-sidebar',
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget' => '</div>',
            'before_title' => '<h3>',
            'after_title' => '</h3>',
        ));
        
        register_sidebar( 
            array(
            'name'            => __( 'Front Page: Content Top Section', 'blogmaster' ),
            'id'              => 'blogmaster-front-page-content-section',
            'description'     => __( 'Content Top Section', 'blogmaster' ),
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget' => '</div>',
            'before_title' => '<h3>',
            'after_title' => '</h3>',
        ));
        
        register_sidebar(
            array(
            'name' => __('Area After First Post', 'blogmaster'),
            'id' => 'blogmaster-post-area',
            'description'     => __( 'Suitable for text widget.', 'blogmaster' ),
            'before_widget' => '<aside id="%1$s" class="widget %2$s">',
            'after_widget' => '</aside>',
            'before_title' => '<h3>',
            'after_title' => '</h3>',
        ));
}
////////////////////////////////////////////////////////////////////
// Register hook and action to set Main content area col-md- width based on sidebar declarations
////////////////////////////////////////////////////////////////////

add_action( 'blogmaster_main_content_width_hook', 'blogmaster_main_content_width_columns');

function blogmaster_main_content_width_columns () {

    $columns = '12';

    if (get_theme_mod( 'rigth-sidebar-check', 1 ) != 0 ) {
        $columns = $columns - esc_attr(get_theme_mod( 'right-sidebar-size', 3 ));
    }

    if (get_theme_mod( 'left-sidebar-check', 0 ) != 0 ) {
        $columns = $columns - esc_attr(get_theme_mod( 'left-sidebar-size', 3 ));
    }

    echo $columns;
}

function blogmaster_main_content_width() {
    do_action('blogmaster_main_content_width_hook');
}

////////////////////////////////////////////////////////////////////
// Add support for a featured image and the size
////////////////////////////////////////////////////////////////////

    add_theme_support( 'post-thumbnails' );
    set_post_thumbnail_size(300,300, true);
    add_image_size( 'blogmaster-home', 731, 441, true );
    add_image_size( 'blogmaster-single', 1170, 450, true );
    add_image_size( 'blogmaster-slider-nav', 234, 131, true );
    
    
////////////////////////////////////////////////////////////////////
// Adds RSS feed links to for posts and comments.
////////////////////////////////////////////////////////////////////

    add_theme_support( 'automatic-feed-links' );


////////////////////////////////////////////////////////////////////
// Set Content Width
////////////////////////////////////////////////////////////////////

if ( ! isset( $content_width ) ) $content_width = 800;

////////////////////////////////////////////////////////////////////
// Breadcrumbs
////////////////////////////////////////////////////////////////////
function blogmaster_breadcrumb () 
{
	global $post, $wp_query;
	$home = __('Home', 'blogmaster');
	$delimiter = ' &raquo; ';
	$homeLink = home_url();
	if (is_home() || is_front_page()) {
		// no need for breadcrumbs in homepage
	}
	else {
		echo '<div id="breadcrumbs" >';
		echo '<div class="breadcrumbs-inner text-right">';
		// main breadcrumbs lead to homepage
		echo '<span><a href="' . esc_url($homeLink) . '">' . '<i class="fa fa-home"></i><span>' . esc_attr($home) . '</span>' . '</a></span>' . $delimiter . ' ';
		// if blog page exists
		if (get_page_by_path('blog')) {
			if (!is_page('blog')) {
				echo '<span><a href="' . esc_url(get_permalink(get_page_by_path('blog'))) . '">' . '<span>Blog</span></a></span>' . $delimiter . ' ';
			}
		}
		if (is_category()) {
			$thisCat = get_category(get_query_var('cat') , false);
			if ($thisCat->parent != 0) {
				$category_link = get_category_link($thisCat->parent);
				echo '<span><a href="' . $category_link . '">' . '<span>' . get_cat_name($thisCat->parent) . '</span>' . '</a></span>' . $delimiter . ' ';
			}
			$category_id = get_cat_ID(single_cat_title('', false));
			$category_link = get_category_link($category_id);
			echo '<span><a href="' . $category_link . '">' . '<span>' . single_cat_title('', false) . '</span>' . '</a></span>';
		}
		elseif (is_single() && !is_attachment()) {
			if (get_post_type() != 'post') {
				$post_type = get_post_type_object(get_post_type());
				$slug = $post_type->rewrite;
				echo '<span><a href="' . esc_url($homeLink) . '/' . $slug['slug'] . '">' . '<span>' . $post_type->labels->singular_name . '</span>' . '</a></span>';
				echo ' ' . $delimiter . ' ' . get_the_title();
			}
			else {
				$category = get_the_category();
				if ($category) {
					foreach($category as $cat) {
						echo '<span><a href="' . get_category_link($cat->term_id) . '">' . '<span>' . $cat->name . '</span>' . '</a></span>' . $delimiter . ' ';
					}
				}
				echo get_the_title();
			}
		}
		elseif (!is_single() && !is_page() && get_post_type() != 'post' && !is_404() && !is_search()) {
			$post_type = get_post_type_object(get_post_type());
			echo $post_type->labels->singular_name;
		}
		elseif (is_attachment()) {
			$parent = get_post($post->post_parent);
			echo '<span><a href="' . get_permalink($parent) . '">' . '<span>' . $parent->post_title . '</span>' . '</a></span>';
			echo ' ' . $delimiter . ' ' . get_the_title();
		}
		elseif (is_page() && !$post->post_parent) {
			$get_post_slug = $post->post_name;
			$post_slug = str_replace('-', ' ', $get_post_slug);
			echo '<span><a href="' . get_permalink() . '">' . '<span>' . ucfirst($post_slug) . '</span>' . '</a></span>';
		}
		elseif (is_page() && $post->post_parent) {
			$parent_id = $post->post_parent;
			$breadcrumbs = array();
			while ($parent_id) {
				$page = get_page($parent_id);
				$breadcrumbs[] = '<span><a href="' . get_permalink($page->ID) . '">' . '<span>' . get_the_title($page->ID) . '</span>' . '</a></span>';
				$parent_id = $page->post_parent;
			}
			$breadcrumbs = array_reverse($breadcrumbs);
			for ($i = 0; $i < count($breadcrumbs); $i++) {
				echo $breadcrumbs[$i];
				if ($i != count($breadcrumbs) - 1) echo ' ' . $delimiter . ' ';
			}
			echo $delimiter . '<span><a href="' . get_permalink() . '">' . '<span>' . the_title_attribute('echo=0') . '</span>' . '</a></span>';
		}
		elseif (is_tag()) {
			$tag_id = get_term_by('name', single_cat_title('', false) , 'post_tag');
			if ($tag_id) {
				$tag_link = get_tag_link($tag_id->term_id);
			}
			echo '<span><a href="' . $tag_link . '">' . '<span>' . single_cat_title('', false) . '</span>' . '</a></span>';
		}
		elseif (is_author()) {
			global $author;
			$userdata = get_userdata($author);
			echo '<span><a href="' . get_author_posts_url($userdata->ID) . '">' . '<span>' . $userdata->display_name . '</span>' . '</a></span>';
		}
		elseif (is_404()) {
			echo __('Error 404', 'blogmaster');
		}
		elseif (is_search()) {
			echo 'Search results for "' . get_search_query() . '"';
		}
		elseif (is_day()) {
			echo '<span><a href="' . get_year_link(get_the_time('Y')) . '">' . '<span>' . get_the_time('Y') . '</span>' . '</a></span>' . $delimiter . ' ';
			echo '<span><a href="' . get_month_link(get_the_time('Y') , get_the_time('m')) . '">' . '<span>' . get_the_time('F') . '</span>' . '</a></span>' . $delimiter . ' ';
			echo '<span><a href="' . get_day_link(get_the_time('Y') , get_the_time('m') , get_the_time('d')) . '">' . '<span>' . get_the_time('d') . '</span>' . '</a></span>';
		}
		elseif (is_month()) {
			echo '<span><a href="' . get_year_link(get_the_time('Y')) . '">' . '<span>' . get_the_time('Y') . '</span>' . '</a></span>' . $delimiter . ' ';
			echo '<span><a href="' . get_month_link(get_the_time('Y') , get_the_time('m')) . '">' . '<span>' . get_the_time('F') . '</span>' . '</a></span>';
		}
		elseif (is_year()) {
			echo '<span><a href="' . get_year_link(get_the_time('Y')) . '">' . '<span>' . get_the_time('Y') . '</span>' . '</a></span>';
		}
		if (get_query_var('paged')) {
			if (is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author()) echo ' (';
			echo __('Page', 'blogmaster') . ' ' . get_query_var('paged');
			if (is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author()) echo ')';
		}
		echo '</div></div>';
	}
}

////////////////////////////////////////////////////////////////////
// Display navigation to next/previous pages when applicable
////////////////////////////////////////////////////////////////////
if ( ! function_exists( 'blogmaster_content_nav' ) ) :
function blogmaster_content_nav( $nav_id ) {
	global $wp_query, $post;

	// Don't print empty markup on single pages if there's nowhere to navigate.
	if ( is_single() ) {
		$previous = ( is_attachment() ) ? get_post( $post->post_parent ) : get_adjacent_post( false, '', true );
		$next = get_adjacent_post( false, '', false );

		if ( ! $next && ! $previous )
			return;
	}

	// Don't print empty markup in archives if there's only one page.
	if ( $wp_query->max_num_pages < 2 && ( is_home() || is_archive() || is_search() ) )
		return;

	$nav_class = ( is_single() ) ? 'post-navigation' : 'paging-navigation';

	?>
	<nav role="navigation" id="<?php echo esc_attr( $nav_id ); ?>" class="<?php echo $nav_class; ?>">
		<div class="screen-reader-text"><?php _e( 'Post navigation', 'blogmaster' ); ?></div>
		<div class="pager">

		<?php if ( is_single() ) : // navigation links for single posts ?>

			<div class="post-navigation row">
        	<div class="post-previous col-md-6"><?php previous_post_link( '%link', '<span class="meta-nav">'. __( 'Previous:', 'blogmaster' ).'</span> %title' ); ?></div>
        	<div class="post-next col-md-6"><?php next_post_link( '%link', '<span class="meta-nav">'. __( 'Next:', 'blogmaster' ).'</span> %title' ); ?></div>
      </div>

		<?php elseif ( $wp_query->max_num_pages > 1 && ( is_home() || is_archive() || is_search() ) ) : // navigation links for home, archive, and search pages ?>

			<?php if ( get_next_posts_link() ) : ?>
			<li class="nav-previous previous btn btn-default"><?php next_posts_link( __( 'Older posts', 'blogmaster' ) ); ?></li>
			<?php endif; ?>

			<?php if ( get_previous_posts_link() ) : ?>
			<li class="nav-next next btn btn-default"><?php previous_posts_link( __( 'Newer posts', 'blogmaster' ) ); ?></li>
			<?php endif; ?>

		<?php endif; ?>

		</div>
	</nav>
	<?php
}
endif; // content_nav


////////////////////////////////////////////////////////////////////
// Pagination
////////////////////////////////////////////////////////////////////
function blogmaster_pagination() {
    global $wp_query;
    $big = 999999999;
    $pages = paginate_links(array(
        'base' => str_replace($big, '%#%', esc_url(get_pagenum_link($big))),
        'format' => '?page=%#%',
        'current' => max(1, get_query_var('paged')),
        'total' => $wp_query->max_num_pages,
        'prev_next' => false,
        'type' => 'array',
        'prev_next' => TRUE,
        'prev_text' => __('&larr; Previous', 'blogmaster' ),
        'next_text' => __('Next &rarr;', 'blogmaster' ),
            ));
    if (is_array($pages)) {
        $current_page = ( get_query_var('paged') == 0 ) ? 1 : get_query_var('paged');
        echo '<ul class="pagination">';
        foreach ($pages as $i => $page) {
            if ($current_page == 1 && $i == 0) {
                echo "<li class='active'>$page</li>";
            } else {
                if ($current_page != 1 && $current_page == $i) {
                    echo "<li class='active'>$page</li>";
                } else {
                    echo "<li>$page</li>";
                }
            }
        }
        echo '</ul>';
    }
}


////////////////////////////////////////////////////////////////////
// Meta functions
////////////////////////////////////////////////////////////////////
function blogmaster_comments() {
    global $post;
	  $args = array(
    	'number' => '1',
    	'post_id' => $post->ID, 
    );
    $comments = get_comments($args);
    $commentslink = get_comments_link( $post->ID );
    if (!empty($comments)) {
    foreach($comments as $comment) :
      $length = 80; // adjust to needed length
    	$thiscomment = $comment->comment_content;
    	if ( strlen($thiscomment) > $length ) {
    	$thiscomment = substr($thiscomment,0,$length);
    	$thiscomment = $thiscomment .'...';
    	}
    	echo '<strong>'. __( 'By: ', 'blogmaster') .'</strong>',(esc_attr($comment->comment_author) . '<br /><p>' . esc_attr($thiscomment) . '</p>');
    endforeach;
    } else {
      echo '<p>'. __( 'No comments', 'blogmaster') .'</p>';  
    }
    echo '<p><a href="'.esc_url( $commentslink ).'" >'. __( 'Add your comment', 'blogmaster') .'</a></p>';
}
function blogmaster_comments_count() {
    global $post;
    $args = array(
    	'post_id' => $post->ID, 
      'count' => true 
    );
    $comments = get_comments($args);
    echo $comments;
}
function blogmaster_cat_list() {
    global $post;
    $categories = get_the_category();
            $separator = ', ';
            if($categories){
              foreach($categories as $category) {
                echo '<span><a href="'.esc_url(get_category_link($category->term_id )).'" title="' . esc_attr( sprintf( __( 'View all posts in %s', 'blogmaster' ), $category->name ) ) . '">' . esc_attr($category->cat_name) . '</a></span>'.$separator;
              }                                                                                                                
            }
}
?>